<?php

/**
 * @file
 * Contains Drupal\url_embed\UrlEmbed.
 */

namespace Drupal\url_embed;

use Drupal\Core\Config\ConfigFactoryInterface;
use Embed\Embed;

/**
 * A service class for handling URL embeds.
 */
class UrlEmbed implements UrlEmbedInterface {

  /**
   * @var array
   */
  public $config;

  /**
   * @{inheritdoc}
   */
  public function __construct(ConfigFactoryInterface $config_factory, array $config = []) {
    $global_config = $config_factory->get('url_embed.settings');
    $defaults = [];
    if($global_config->get('facebook_app_id') && $global_config->get('facebook_app_secret')){
      $defaults['facebook']['key'] = $global_config->get('facebook_app_id') . '|' . $global_config->get('facebook_app_secret');
    }
    $this->config = array_replace_recursive($defaults, $config);
  }

  /**
   * @{inheritdoc}
   */
  public function getConfig() {
    return $this->config;
  }

  /**
   * @{inheritdoc}
   */
  public function setConfig(array $config) {
    $this->config = $config;
  }

  /**
   * @{inheritdoc}
   */
  public function getEmbed($request, array $config = []) {
    return Embed::create($request, array_replace_recursive($this->config, $config));
  }

}
